alias: TFBRT = Thanks for Bug Report to

What's new
----------
v2.06.1
	- Fixed the ProgressBar bugs (mainly: going back to 0% and not closing)
v2.06.0
	- Added a (poor) graphical progress bar (check GUI, option ProgressBar)
	- Cleaned changes of 2.05.3
	- In case some network settings were deleted, patchbot will try to load
	  network config files found on disk whenever the corresponding network
	  is selected/added through the GUI
	- Corrected a typo
v2.05.3
	- If fserver is off, the file is directly sent, and you loose all benefits
	  of SysReset management (firewall, resends, ...)
v2.05.2
	- Changed colors for fatal error message
	- Repaired the webupdater
v2.05.1 Dedicated to Tekkanano and his great help
	- Probably fixed some more dll loading problem		(TFRBT Tekkanano)
	- Corrected a typo (well, kind of, but that's all that matters to the user :)
								(TFRBT Tekkanano)
	- Probably fixed some antiflood stuff			(TFRBT Tekkanano)
	- Fixed bug when a folder added is used by a SysReset trigger, but isn't
	  cached by @find, which led patchbot to think it was.	(TFRBT Tekkanano)
	- Removed the burnt-in limit for HD rate limit (thus new dll, version 1.8)
	- Remember the last folder selected (so, most often, the last one added
	  and will use its parent folder as start point for adding a folder.
	- Now instasend the cdt if you're sending files		(TFRBT Tekkanano)
							(thx a bunch again Rz_Ten1)
	- Fixed some script (un)loading problems on fatal errors
								(TFRBT Tekkanano)
	- The verbose option displays in blue in the status windows the succesfull
	  operations.
v2.05
	- Use SysReset parameters to bypass firewall when sending cdt files. It
	  may still fail if IPs aren't up-to-date (too lazy to fix that, and
	  SysReset may handle this better). This usefull feature justify a new
	  version						(TFRBT Hentai_Guy)
	- Previous fix for undeleted files was only working for server side. Now
	  also works for client.				(TFRBT Shinji_Ikari)
	- SendCDT will remember the last browsed folder, or revert to mIRC's folder
	  if it doesn't exist anymore.
	- 
v2.04.3
	- Fixed cdt and cdp not deleted on the server side (maybe -_-)
	  (TFBRT Akari and thanks a bunch for testing that)
	- Fixed dll not found when drive letter/path changes	(TFRBT Shinji_Ikari)
	- Added more complete feedback when 'an unknown error occurs' (TFBRT Eazy)
	- Actually checks the CDP storage existence (in addition to the fact it was
	  set)							(TFBRT Eazy)
	- Doesn't report the fullname of the patch (ie removes the path in the
	  filename, for [probably small] privacy matters)	(TFBRT Eazy)
v2.04.2
	- Fixed 'Antiflood triggered', which was the only thing shown after a
	  while (TFRBT Frst)
v2.04.1
	- Fixed 'server replies' getting ticked again (TFBRT Frst + Felizk)
	- Updated FAQ.html for the ones having trouble running patchbot with
	  Windows 2000 Advanced Server (Thanks Nono_Rbot)
v2.04
	- !list behaviour from 2.03.6
	- Fixed incomplete listing in /pchanstats when IAL has to be updated
v2.03.6
	- Only for test, not released
	- The "server replies" tick affect how patchbot reacts to !list (unticked =
          doesn't react)
v2.03.5
	- Fixed maximum cdp filesize not verified
	- Quick hack to support private servers or servers from an unknown
	  network
v2.03.4
	- When used in plain sysreset, C@che won't be greyed out anymore.
v2.03.3
	- More detailed help in /ctcp <nick> help
	- 'Current' button no more available in the GUI if added manually
								(TFRBT Jed)
v2.03.2
	- Removed some useless text echo'ed.
v2.03	FINAL
V2.02 (close to final)
	- Fixed '/off - not connected to server' error message
	- Fixed advertisement not displaying when a !list is typed
	- Fixed version displayed in adddon manager		(TFRBT Ravlen)
	- Fixed network not being detected			(TFBRT Akari)
	- Recaching won't keep working even if disabled		(TFBRT Ginnosuke)
	- This recache won't update @find caches (was uselessly done)
	- SendCDT won't be reenabled if the recache is working
	- No more 'Your status in current queue...' message	(TFRBT Ravlen)
v2.01 (RC6b)
	- Fixed HUUUUGE bug which made the patchbot not working at all (dll was
	  unloaded too soon by mIRC) -> dll v1.7		(TFBRT Ginnosuke)
	- Fixed N/A appearing in status window when someone !list you (TFBRT
	  Worde and Ginnosuke, thanks for help Rz_Ten1)
v2.0 (RC6)
	- 'Big' changes in the dll: v1.6
	- Those changes enables the addon to continue processing as soon as thd
	  dll finishes its job (the addon was checking every 10s before)
	- You can now select to display the progress every X s, and what progress
	  (cdt or cdp building).
	- Now, replies to list command in channels monitored.	(TraXeN)
	  It won't get you voiced by most (any) addon, though.
	- Recache is now on par with @find addon: possibility to recache already
	  cached folders on load (mIRC or addon) or on a regular basis.
	- Default speed is now 6000KB/s: it should speed things up with no
	  noticeable drawback
	- Appropriate change in the GUI, for all those little features
	- Fixed !patch command replying when server is offline	(TFBRT Rz_Ten1)
	- Fixed !patch command reporting 0 files found		(TFBRT Rz_Ten1)
	- Fixed uncomplete results when finding matches over several folders.
	- Remove useless code maybe causing mIRC lockups if mIRC/comp had crashed
	  before reloading (TFBRT Averia and Akari)
	- Shortened code					(Rz_Ten1)
v1.8.1 (=RC5)
	- progress report (displayed every 10s) back on client side (and not
	  server side)
	- If you happen to delete CDP storage folder, it will automatically be
	  replaced with a default one, namely mIRC/SysReset default root folder.
	- Fixed unsaved network settings on exit (unloading was ok)
								(TFBRT KktoMx)
	- Biggest news: also reports CRC. This can't be disabled and takes
	  some additional time. Just increase HD rate to 6000 or 8000, that is
	  quite sufficient (latest 7200rpm disks should be able to handle
	  20000 or more, I guess)
	- /patchbot crc to recall the last CRC reported after patching.
	- In case you wonder, /patchbot without argument display list of
	  available 
	- some errors than may occur when sending .cdt after SendCDT
	- Correctly wipes GUI when last network is deleted
	- /pchanstast now also update internal list of addresses if needed.
	  It wasn't done previously, and could lead to people not being
	  reported as not running patchbot (although they were counted in
	  number of voiced/regulars/ops).
	- Fixed some cancels (due to @find replies badly interpreted)
v1.8 (=RC4b)
	- Fixed lame+stupid bug due to a typo. Affected loading for
	  first-time runners					(TFBRT TurboBee)
	- Most debug outputs is disabled. /set %patchbot.debug 1 if you
	  want them back
	- No more autojoin on #patchbot (leftover of debug mode)
	- Major addition: now supports caching by either @find or internal
	  For now, disabling caching by @find isn't possible, you'll have to
	  do it by hand in @find manager
	- Separated patchbot stats from non-patchbots. Command for it is
	  /patchbot non
v1.7RC3
	- Minor changes in /pchanstats
	  . more SysReset-ish, if under SysReset)
          . You're not included anymore in the list (d'oh)
	- Bug fixes in /pchanstats:
	  . Invalid stats
	  . Possible errors when using command (hash table Pchanlist, etc)
	- Fixed networks not saved properly / creation of a file 'Program' in
	  C:\ (TFBRT Kogi). This bug was said to also prevent any program
	  located in "C:\Program Files\" from running... o_O
v1.7RC2
	- Fixed deletion of cdt file when using /patchbot delcdt (it was kept)
	- Fixed bugs with @find caching (after removal, for !patch command)
	  (TFBRT TraXeN and Ginnosuke)
	- New OP-only command: /pchanstats			(TraXeN)
	  Will broadcast to the active window (if channel) or provided channel
	  a query for version.
	  After 30s, will echo stats to active window, and write verbose log
	  to pchanstats.log
	  Not very accurate as it doesn't update internal list (some servers
	  which left or arrived during stats listing are not included)
v1.7RC1
	- add_queue works (no pushfile or prioritizing, though)
	- also works under plain mIRC, so Release Candidate time!
v1.6.9
	- Doesn't ask anymore to confirm deletion of generated cdt file on error
	  For any error generated on client side, you must confirm to keep the
	  file. This is also needed if you want to reenable immediately patchbot
	  (both client and server side)
	- Therefore, a command was added: /patchbot		(TaurUrgas)
	  Without argument, will display list of valid arguments, that is:
          . uldll   : Unload DLL
          . savecdt : Reset Patchbot after an error after sending cdt, which is
            kept
          . delcdt  : Same as above, but deletes cdt file
        - /prst removed. Le roi est mort, vive le roi
v1.6.8	Trying to reach RC status...
	- Fixes in GUI initialization
	- More fixes to non-SysReset mIRC...
v1.6.7
	- List of servers no more erased on unload
	- Fixed bug with multiple dirs in !patch command
	- Fixed "reply to !patch": works (but affects all servers and channels)
	- Renamed it to "Server replies"
	- Fixed ON/OFF for patchbot (maybe an error introduced while coding 1.6)
	  !patch available as text and ctcp trigger: avoid flooding channel with
	  unwanted char strings :p
	- NOT fixed: cdp not sending since queue management was added, working
	  on that
	- Command /prst to reset the client (do not use while a processing
	  is working, only when the Client side wasn't properly reset, after a
	  bug or a timeout).
v1.6.6
	- Now uses queue management of SysReset, if SysReset installed
	- First modifications to run it on mIRC without SysReset
	- SendCDT command in Nicklist is disabled when a patch is being
	  processed
v1.6.5
	- Fixed small bug in !patch command
	- Fixed immediate timeout when waiting for a CDP (client side)
v1.6.4
	- Fixed initialization of CDP Storage path on first run.
	- Fixed blocksize display in GUI initializing
v1.6.3
	- Fixed a crash in zidrav.dll for files that have a size multiple of
	  blocksize (when making a CDT file)
	-> v.1.5 of zidrav.dll
v1.6.2
	!patch even closer to @find
v1.6.1
	- Rewritten a bit the GUI code - maybe bugs have appeared.
	- !patch command acts a little more like @find. Not as good, but
	  sufficient.
	- Versions are now only for internal use, as some bugs bring it back
	  to beta status...
v1.6.0
	- Already a change! :)
	- You can now select which queue pool will be used to send patches. I
	  write 'will' because I'd like people to tell me how they'd like to
	  use queues (more particularly what parameters to use add_queue, for
	  the ones who know that sysreset function)
	- For now, this also means that it will only work in sysreset
v1.5.0
	- Redone a bit the GUI in order to fit it into 800x600 screen :p (daat99)
	- Now has less confusing ON _and_ OFF buttons
v1.4.1-2
	- Quick workaround when Zidrav.dll couldn't be loaded (due to FAT16 and
	  space character(s) in path, I believe)
	- Will exit immediately in order not to mess with internal settings.
v1.4.0
	- Now !patch (instead of !p@tch) can take an argument to search (in order
	  to find the right syntax for sending a cdp): !patch eps 42 (should work
	  close to what does @find addon)
	- Now the button ON/OFF indicates the state that is reached by pressing
	  it (therefore: ON will switch it on)
v1.3.8
	- Reflected changes made to the dll (hence the v1.4) earlier
	- By request, the DLL won't change to idle mIRC process priority (but
	  threads will remain at idle in order not to lock the comp)
	- Fixed some typos (sorry KKtoMx and TraXeN)
v1.3.6-7
	- Refresh the channels (empty it) when adding a new folder
	- Checking the status can be done more than once, if checked less than
	  once every 10s
v1.3.4-5
	- Script in debug mode: will maybe join #patchbot if connected, but
	  you'll have to set manually networks, folders and channels.
	- Various fixes to server side. If file used as source for buidling cdt
	  is corrupt and server got it as source file and can build cdp (ie you're
	  on a channel, it's free, etc), the patching is ok. Otherwise, too little
	  tests. (It's funny re-reading old things, that one sure is hard to
	  understand)
v1.3.3
	- More logging
	- Fixed an useless popup from zidrav.dll

v1.1.0 - v1.3.2
	!p@tch triggers, and private /ctcp bot status		 (KKtoMix)
	Returns the status of patchbot:
	  - disabled
	  - in pause, and how many time left
	  - working, how many % done
	  - free/ready to use
	As a ctcp trigger, protected from flood by SysReset protections

	A logger (file patchbot.log)				 (TraXeN)
	(whatlocaldate - whatlocaltime) Info
	Example (display may change depending on several settings):
	(18/09/2002 - 14:21:40) Sent Movie1.avi.cdt to Kurosu

	A HD speed limiter					 (TaurUrgas)
	Try to (not efficiently) limit data transfers on HD at a certain speed,
	say 2 MegaBytes/s, i.e. 2048 KBytes/s

	Timeout on client side (sends are ok, I don't think the "patching when
	CDP received" works - especially, don't send cdt by this way, although
	it should be possible in the end)

Improvements in zidrav.dll (might be used in zidrav project).